//+------------------------------------------------------------------+
//|                                                zero lag nema.mq4 |
//|                                                           mladen | 
//+------------------------------------------------------------------+
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2

//
//
//
//
//

extern int NemaPeriod = 25;
extern int NemaPrice  = PRICE_CLOSE;
extern int NemaDepth  = 10;

//
//
//
//
//

double nema[];
double work[][50][2];
double coeff[50];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorDigits(6);
   SetIndexBuffer(0,nema);
         NemaDepth = MathMax(MathMin(NemaDepth,49),1);
         for(int k=0; k<=NemaDepth; k++)
               coeff[k] = factorial(NemaDepth)/(factorial(NemaDepth-k)*factorial(k));
   return(0); 
}
int deinit(){ return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
         
   //
   //
   //
   //
   //
    
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,NemaPrice,i);
      double nema1 = iNema(price,NemaPeriod,r,0);
      double nema2 = iNema(nema1,NemaPeriod,r,1);
             nema[i] = 2.0*nema1-nema2;
   }       
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iNema(double price, double period, int r, int forValue)
{
   double alpha  = 2.0/(1.0+period);
   double result = 0;
   double sign   = 1;
 
   for (int k=0; k<NemaDepth; k++, sign *= -1)
   {
      if (r<2)
            work[r][k][forValue] = price;
      else  work[r][k][forValue] = work[r-1][k][forValue]+alpha*(price-work[r-1][k][forValue]);
      price  = work[r][k][forValue];
      result += price*sign*coeff[k+1];
   }
   return(result);               
}

//
//
//
//
//

double factorial(int n)
{
   double a=1; for(int i=1; i<=n; i++) a*=i;
   return(a);
}